unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdHTTP, Xml.xmldom, Xml.XMLIntf,
  Xml.Win.msxmldom, Xml.XMLDoc, Vcl.ExtCtrls, Vcl.StdCtrls, System.UITypes,
  Vcl.Imaging.jpeg, Math;

type
  TMainFrm = class(TForm)
    HTTP: TIdHTTP;
    Screen: TImage;
    ImgHTTP: TIdHTTP;
    Panel: TPanel;
    X: TLabeledEdit;
    Y: TLabeledEdit;
    Z: TLabeledEdit;
    Button1: TButton;
    MovTimer: TTimer;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure LoadTile(const X, Y, Z: string; const Xmov, Ymov: integer; const Around: boolean; sett: boolean = false);
    procedure Button1Click(Sender: TObject);
    procedure ScreenMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ScreenMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MovTimerTimer(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainFrm: TMainFrm;
  Cur: TPoint;
  Xmid, Ymid, ZG, XmovG, YmovG: integer;
  Cities, Routes, Crs: IXMLDocument;

implementation

{$R *.dfm}

procedure Clear;
begin
  MainFrm.Screen.Canvas.Brush.Color := clGray;
  MainFrm.Screen.Canvas.FillRect(rect(0, 0, 768, 768));
end;

procedure TMainFrm.LoadTile(const X, Y, Z: string; const Xmov, Ymov: integer; const Around: boolean; sett: boolean = false);
var
  Stream: TMemoryStream;
  Image: TJPEGImage;
  Xi, Yi, Zi, i, j, Xm, Ym: integer;
begin
  Xi := StrToInt(X);
  Yi := StrToInt(Y);
  Zi := StrToInt(Z);

  if NOT((Xi < 0) OR (Xi > (Math.Power(2, Zi))*3-1) OR (Yi < 0) OR (Yi > (Math.Power(2, Zi))*2-1)) then begin
    if NOT(FileExists(X+Y+Z+'.jpg')) then begin
      Stream := TMemoryStream.Create;

      ImgHTTP.Get('http://192.168.2.76/'+Z+'/'+X+'/'+Y+'.jpg', Stream);

      Stream.SaveToFile(X+'-'+Y+'-'+Z+'.jpg');

      Stream.Free;
    end;

    Image := TJPEGImage.Create;
    Image.LoadFromFile(X+'-'+Y+'-'+Z+'.jpg');

    Screen.Picture.Bitmap.Canvas.Draw(Xmov, Ymov, Image);

    if (Sett) then begin
      Xmid := Xi;
      Ymid := Yi;
      ZG := Zi;
      XmovG := Xmov;
      YmovG := Ymov;
    end;

    if (Around) then begin
      MainFrm.X.Text := X;
      MainFrm.Y.Text := Y;
      MainFrm.Z.Text := Z;

      Xm := Xmov - 512;
      for i := Xi-2 to Xi+2 do begin
        Ym := Ymov - 512;
        for j := Yi-2 to Yi+2 do begin
          LoadTile(IntToStr(i), IntToStr(j), Z, Xm, Ym, false);
          Ym := Ym + 256;
        end;
        Xm := Xm + 256;
      end;
    end;
  end;
end;

procedure TMainFrm.MovTimerTimer(Sender: TObject);
begin
  if (Mouse.CursorPos.X - Cur.X > 256) then begin
    Xmid := Xmid - 1;
    Cur.X := Cur.X + 256;
  end;
  if (Mouse.CursorPos.Y - Cur.Y > 256) then begin
    Ymid := Ymid - 1;
    Cur.Y := Cur.Y + 256;
  end;
  if (Mouse.CursorPos.X - Cur.X < -256) then begin
    Xmid := Xmid + 1;
    Cur.X := Cur.X - 256;
  end;
  if (Mouse.CursorPos.Y - Cur.Y < -256) then begin
    Ymid := Ymid + 1;
    Cur.Y := Cur.Y - 256;
  end;

  Clear;
  LoadTile(IntToStr(Xmid), IntToStr(Ymid), IntToStr(ZG), XmovG + (Mouse.CursorPos.X - Cur.X), YmovG + (Mouse.CursorPos.Y - Cur.Y), true);
end;

procedure TMainFrm.ScreenMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Cur := Mouse.CursorPos;
  MovTimer.Enabled := true;
end;

procedure TMainFrm.ScreenMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  MovTimer.Enabled := false;

  XmovG := XmovG + (Mouse.CursorPos.X - Cur.X);
  YmovG := YmovG + (Mouse.CursorPos.Y - Cur.Y);

  if (XmovG > 512) then begin
    Xmid := Xmid - 1;
    XmovG := XmovG - 256;
  end;
  if (YmovG > 512) then begin
    Ymid := Ymid - 1;
    YmovG := YmovG - 256;
  end;
  if (XmovG < 0) then begin
    Xmid := Xmid + 1;
    XmovG := XmovG + 256;
  end;
  if (YmovG < 0) then begin
    Ymid := Ymid + 1;
    YmovG := YmovG + 256;
  end;
end;

procedure TMainFrm.Button1Click(Sender: TObject);
begin
  if (X.Text = '') then X.Text := '0';
  if (Y.Text = '') then Y.Text := '0';
  if (Z.Text = '') then Z.Text := '0';
  if (StrToInt(Z.Text) > 9) then Z.Text := '9';
  if (StrToInt(Z.Text) < 0) then Z.Text := '0';
  if (StrToInt(X.Text) > (Math.Power(2, StrToInt(Z.Text)))*3-1) then X.Text := IntToStr(Round(Math.Power(2, StrToInt(Z.Text))*3-1));
  if (StrToInt(X.Text) < 0) then X.Text := '0';
  if (StrToInt(Y.Text) > (Math.Power(2, StrToInt(Z.Text)))*2-1) then Y.Text := IntToStr(Round(Math.Power(2, StrToInt(Z.Text))*2-1));
  if (StrToInt(Y.Text) < 0) then Y.Text := '0';

  Clear;

  LoadTile(X.Text, Y.Text, Z.Text, 256, 256, true, true);
end;

procedure TMainFrm.Button2Click(Sender: TObject);
var
  City, ZoomS: string;
  Zoom, i: integer;
  FCities: array of integer;
  FCity: IXMLNode;
begin
  City := InputBox('Zadejte jmno msta', 'Zadejte jmno msta', '');
  if NOT(City = '') then begin
    ZoomS := InputBox('Zadejte piblen', 'Zadejte piblen', '5');
    try
      Zoom := StrToInt(ZoomS);
    except
      MessageDlg('Mus bt zadno slo.', mtError, [mbOK], 0);
      Exit;
    end;

    if (Zoom < 0) then Zoom := 0;
    if (Zoom > 9) then Zoom := 9;

    SetLength(FCities, 0);
    for i := 0 to Cities.DocumentElement.ChildNodes.Count-1 do begin
      if (Cities.DocumentElement.ChildNodes[i].GetAttribute('jmno') = City) then begin
        SetLength(FCities, Length(FCities)+1);
        FCities[High(FCities)] := i;
      end;
    end;

    case Length(FCities) of
      0: begin
        MessageDlg('Nebylo nalezeno dn msto.', mtWarning, [mbOK], 0);
      end;
      1: begin
        FCity := Cities.DocumentElement.ChildNodes[FCities[0]];

        Clear;
        LoadTile(IntToStr(Round(FCity.GetAttribute('x') / (Math.Power(2, (9-Zoom))*256))), IntToStr(Round(FCity.GetAttribute('y') / (Math.Power(2, (9-Zoom))*256))), IntToStr(Zoom), 256, 256, true, true);
      end;
      else begin
        try
          i := StrToInt(InputBox('Bylo nalezeno '+IntToStr(Length(FCities))+' mst', 'Vyberte msto', '0'));
        except
          MessageDlg('Muste zadat slo', mtError, [mbOK], 0);
          Exit;
        end;

        FCity := Cities.DocumentElement.ChildNodes[FCities[i]];

        Clear;
        LoadTile(IntToStr(Round(FCity.GetAttribute('x') / (Math.Power(2, (9-Zoom))*256))), IntToStr(Round(FCity.GetAttribute('y') / (Math.Power(2, (9-Zoom))*256))), IntToStr(Zoom), 256, 256, true, true);
      end;
    end;
  end;
end;

procedure TMainFrm.FormCreate(Sender: TObject);
var
  Stream: TMemoryStream;
begin
  Screen.Canvas.Create;
  Clear;

  Stream := TMemoryStream.Create;

  try
    HTTP.Get('http://192.168.2.76/obce.xml', Stream);

    Cities := NewXMLDocument;
    Cities.LoadFromStream(Stream, xetUTF_8);
  except

  end;

  try
    HTTP.Get('http://192.168.2.76/rozcestniky.xml', Stream);

    Crs := NewXMLDocument;
    Crs.LoadFromStream(Stream, xetUTF_8);
  except

  end;

  try
    HTTP.Get('http://192.168.2.76/trasy.xml', Stream);

    Routes := NewXMLDocument;
    Routes.LoadFromStream(Stream, xetUTF_8);
  except

  end;

  Stream.Free;

  if NOT(DirectoryExists('cache')) then
    CreateDir('cache');
  SetCurrentDir('cache');

  LoadTile('1', '1', '0', 256, 256, true, true);
end;

procedure TMainFrm.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  if (ZG > 0) then ZG := ZG - 1;
  Xmid := Xmid div 2;
  Ymid := Ymid div 2;

  Clear;
  LoadTile(IntToStr(Xmid), IntToStr(Ymid), IntToStr(ZG), XmovG, YmovG, true);

  Handled := true;
end;

procedure TMainFrm.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  if (ZG < 9) then ZG := ZG + 1;
  Xmid := Xmid * 2;
  Ymid := Ymid * 2;

  Clear;
  LoadTile(IntToStr(Xmid), IntToStr(Ymid), IntToStr(ZG), XmovG, YmovG, true);

  Handled := true;
end;

end.
